import operator
from functools import reduce
import mindspore as ms
from mindspore.ops.primitive import _primexpr


@_primexpr
def _get_tuple_numel(input):
    return reduce(operator.mul, list(input))


@ms.jit_class
class Size(tuple):
    def __new__(cls, shape):
        _shape = shape
        if not isinstance(_shape, (tuple, list)):
            raise TypeError("{} object is not supportted.".format(type(shape)))
        return tuple.__new__(Size, _shape)

    def numel(self):
        return _get_tuple_numel(self)

    def __repr__(self):
        return "mindtorch.Size(" + str(list(self)) + ")"
